'use strict';

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var React = require('react');
var React__default = _interopDefault(React);

/*! *****************************************************************************
Copyright (c) Microsoft Corporation. All rights reserved.
Licensed under the Apache License, Version 2.0 (the "License"); you may not use
this file except in compliance with the License. You may obtain a copy of the
License at http://www.apache.org/licenses/LICENSE-2.0

THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
MERCHANTABLITY OR NON-INFRINGEMENT.

See the Apache Version 2.0 License for specific language governing permissions
and limitations under the License.
***************************************************************************** */

function __spreadArrays() {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
}

var highlightClassName = 'react-highlight';
var styles = "\n  ." + highlightClassName + " {\n    background-color: #f8ffb4;\n    transition: all 0.5s ease-in-out;\n  }\n";
var styleSheet = document.createElement('style');
styleSheet.type = 'text/css';
styleSheet.innerText = styles;
document.head.appendChild(styleSheet);

var ChangeHighlight = function (_a) {
    var children = _a.children, _b = _a.showAfter, showAfter = _b === void 0 ? 500 : _b, _c = _a.hideAfter, hideAfter = _c === void 0 ? 2500 : _c, _d = _a.containerClassName, containerClassName = _d === void 0 ? '' : _d, _e = _a.highlightStyle, highlightStyle = _e === void 0 ? highlightClassName : _e, _f = _a.disabled, disabled = _f === void 0 ? false : _f;
    var _g = React.useState(), oldChildren = _g[0], setOldChildren = _g[1];
    var _h = React.useState([]), listOfHighlightedElements = _h[0], setListOfHighlightedElements = _h[1];
    var isInitialMount = React.useRef(true);
    var showHighlight = function (element, showAfter, hideAfter) {
        var classNames = element.ref.current.className;
        var isHighlighted = element.ref.current.className.includes(highlightStyle);
        if (!isHighlighted) {
            setTimeout(function () {
                element.ref.current.className += ' ' + highlightStyle;
            }, showAfter);
        }
        else {
            element.ref.current.className =
                classNames.indexOf(highlightStyle) &&
                    classNames.substr(0, classNames.indexOf(highlightStyle)).trim();
            showHighlight(element, showAfter);
        }
    };
    var hideHighlight = function (element, hideAfter, oneElement) {
        setTimeout(function () {
            var classNames = element.ref.current.className;
            if (classNames.indexOf(highlightStyle) > -1) {
                element.ref.current.className = classNames
                    .substr(0, classNames.indexOf(highlightStyle))
                    .trim();
            }
            oneElement.highlighted = true;
        }, hideAfter);
    };
    var checkChangedChildren = function (children, oldChildren) {
        React__default.Children.forEach(oldChildren, function (oldChild, index1) {
            React__default.Children.forEach(children, function (newChild, index2) {
                if (index1 === index2) {
                    if (oldChild.ref &&
                        newChild.props.children !== oldChild.props.children) {
                        if (newChild.props.children) {
                            setListOfHighlightedElements(__spreadArrays(listOfHighlightedElements, [
                                { element: newChild, hideAfter: hideAfter }
                            ]));
                            showHighlight(newChild, showAfter);
                        }
                        setOldChildren(children);
                    }
                }
            });
        });
    };
    React.useEffect(function () {
        if (disabled)
            return;
        if (isInitialMount.current) {
            isInitialMount.current = false;
            setOldChildren(children);
        }
        else {
            checkChangedChildren(children, oldChildren);
        }
    });
    var pickNotHighlightedElement = function (allChanged, idx) {
        if (idx === void 0) { idx = 0; }
        var oneElement;
        if (idx < allChanged.length) {
            oneElement = listOfHighlightedElements[idx];
            if (oneElement.highlighted) {
                pickNotHighlightedElement(allChanged, idx++);
            }
        }
        return oneElement;
    };
    React.useEffect(function () {
        var length = listOfHighlightedElements.length;
        if (length) {
            var oneElement = pickNotHighlightedElement(listOfHighlightedElements);
            if (oneElement) {
                var element = oneElement.element, hideAfter_1 = oneElement.hideAfter;
                hideHighlight(element, hideAfter_1, oneElement);
            }
        }
    }, [listOfHighlightedElements]);
    return React__default.createElement("div", { className: containerClassName }, children);
};

module.exports = ChangeHighlight;
